package behaviors;

import javax.vecmath.Vector3f;

import opensteer.LocalSpace;
import opensteer.SteerVehicle;


public class ArrivalBehavior extends SeekBehavior {
	
	private float slowingDistance;
	private float stopDistance;
	boolean stopped = false;

	public ArrivalBehavior(Vector3f target, float slowingDistance, float stopDistance) {
		super(target);
		
		this.slowingDistance = slowingDistance;
		this.stopDistance = stopDistance;
	}

	@Override
	public boolean steer(SteerVehicle steerVehicle, Vector3f steerForce) {
		
		if ( ! stopped ) {
			
			Vector3f force = steerVehicle.xxxsteerForArrive(target, slowingDistance);
			
			if ( force == LocalSpace.ZERO ) {
				
				stopped = true;
				return false;
			}
			else steerForce.add(force);
			
			return true;
		}
		else return true;
	}
}
