package behaviors;

import java.util.List;

import javax.vecmath.Vector3f;

import opensteer.AbstractVehicle;
import opensteer.LocalSpace;
import opensteer.SimpleVehicle;
import opensteer.SteerVehicle;


public class AvoidNeighboursBehavior implements SteeringBehavior {
	
	private List<SimpleVehicle> vehicles;
	private float timeToColision;


	public AvoidNeighboursBehavior(List<SimpleVehicle> vehicles, float timeToColision) {
		super();

		this.vehicles = vehicles;
		this.timeToColision = timeToColision;
	}


	public boolean steer(SteerVehicle steerVehicle, Vector3f steerForce) {

		Vector3f avoidForce = steerVehicle.xxxsteerToAvoidNeighbors(timeToColision,vehicles);
		
		if ( avoidForce.equals(LocalSpace.ZERO) ) {
			
			return false;
		}
		else {
			steerForce.add(avoidForce);
			return true;
		}
	}

}
