package behaviors;
import java.util.List;
import java.util.Set;

import javax.vecmath.Vector3f;

import opensteer.LocalSpace;
import opensteer.Obstacle;
import opensteer.SteerVehicle;

public class AvoidObstaclesBehavior implements SteeringBehavior {
	
	private List<Obstacle> obstacles;

	public AvoidObstaclesBehavior(List<Obstacle> obstacles) {

		this.obstacles = obstacles;
	}

	public boolean steer(SteerVehicle steerVehicle, Vector3f steerForce) {

		Vector3f avoidForce = steerVehicle.steerToAvoidObstacles(obstacles,5);
		
		if ( avoidForce.equals(LocalSpace.ZERO) ) {
			
			return false;
		}
		else {
			
			steerForce.add(avoidForce);
			return true;
		}
	}

}
