/*
 * Created on 16.12.2006
 *
 */
package behaviors;

import javax.vecmath.Vector3f;

import opensteer.LocalSpace;
import opensteer.Pathway;
import opensteer.SteerVehicle;

public class PathFollowingBehavior implements SteeringBehavior {
	
	private Pathway pathway;
	private float predictionTime;
	
	/**
     * @param pathway
     * @param predictionTime
     */
    public PathFollowingBehavior(Pathway pathway, float predictionTime) {
	    this.pathway = pathway;
	    this.predictionTime = predictionTime;
    }
    
	public boolean steer(SteerVehicle steerVehicle, Vector3f steerForce) {

		Vector3f pathForce = steerVehicle.steerForPathFollowing(predictionTime, pathway);
		
		if ( pathForce.equals(LocalSpace.ZERO) ) {
			
			return false;
		}
		else {
			
			steerForce.add(pathForce);
			return true;
		}
	}

}
