package core;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.Iterator;

import javax.swing.event.MouseInputAdapter;

import common.Catchable;


public class MyInputAdapter extends MouseInputAdapter {
	
	public ArrayList shapes;
	
	public MyInputAdapter(ArrayList shapes) {
		
		this.shapes = shapes;
	}

	public void mouseClicked(MouseEvent e) {
		
		System.out.println("Mouse at: " + e.getPoint() );

		for (Iterator iter = this.shapes.iterator(); iter.hasNext();) {
			
			Object shape = iter.next();
			
			if ( shape instanceof Catchable ) {
				Catchable cShape = (Catchable)shape;
			
				if ( cShape.isCatch(e.getX(), e.getY())) {
				
					System.out.println(shape + " clicked");
				}
			}
		}
	}
}
