package core;


import java.awt.*;
import java.awt.image.BufferedImage;

import javax.swing.*;
import javax.vecmath.Matrix3f;

import common.DirectDrawable;
import common.Drawable;

import java.util.*;


/*
 * Created on 3.11.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author Dusan Fedorcak
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class PaintBox2D extends JFrame implements Observer {

	protected ArrayList shapes = new ArrayList();
	private MyPanel myPanel = new MyPanel();
	
	protected Matrix3f window = null;
	protected BufferedImage buffer = null;

	protected class MyPanel extends JPanel {
    	public void paint(Graphics g) {
    		
    		super.paint(g);
    		//this.setBackground(new Color(64,200,64));
    		drawContent(g);
    	}
	}

	public PaintBox2D(int width, int height) {
		
		super();
		
		this.window = new Matrix3f();
		
		window.setIdentity();
		window.setElement(1,1,-1);	
		window.setElement(0,2, 5);
		window.setElement(1,2, height - 35);
		
		this.getContentPane().add(myPanel);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		myPanel.addMouseListener(new MyInputAdapter(this.shapes));
		
		this.buffer = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
	
		this.setSize(width, height);
	}

	public void render() {
		
		System.out.println("Starting GUI...");
		this.setResizable(true);
		this.setTitle("PaintBox 2D");
		this.setVisible(true);
		
		this.drawDirect();
	}
	
	public synchronized void drawContent(Graphics g) {
		
		g.drawImage(buffer, 0, 0, this);
		
		Iterator i = this.shapes.iterator();

		i = this.shapes.iterator();

		while ( i.hasNext() ) {
			Object o = i.next();
			
			if ( o instanceof Drawable ) {
				
				Drawable prvek = (Drawable) o;
				prvek.draw(g, this.window);
			}
		}
		
		g.setColor(Color.magenta);
		g.drawLine(5,733,85,733);
		g.drawLine(5,733,5,653);
		
		g.drawString("X",95,723);
		g.drawString("Y",15,643);
	}

	public void addToCanvas(Object shape) {

		this.shapes.add(shape);
	}

	public ArrayList getShapes() {
		return shapes;
	}
	
	public void drawDirect() {
		
		Iterator i = this.shapes.iterator();
		
		Graphics2D g2 = buffer.createGraphics();

		i = this.shapes.iterator();

		while ( i.hasNext() ) {
			Object o = i.next();
			
			if ( o instanceof DirectDrawable ) {
				
				DirectDrawable prvek = (DirectDrawable) o;
				prvek.drawDirect(g2, this.window);
			}
		}
	}

	public void update(Observable o, Object arg) {
		
		this.repaint();
	}
}
