package core;

import common.Updatable;

public class Timer extends Thread {
	
	private Updatable updatable;
	private int interval;
	
	private boolean terminated = false;
	private boolean paused = true;
	
	public Timer(Updatable updatable, int interval){
		
		this.updatable = updatable;
		this.interval = interval;
	}
	
	public void run() {
		
		while( !terminated ){
				
			try{
				
				synchronized (this) {
					
				
					if ( !paused ) {
						Thread.sleep(interval);
					
					}
					else this.wait();
					
					updatable.update();
				}
			}
			catch(Exception e){
				e.printStackTrace();
			}
		}
    }
	
	public void terminate() {
		
		this.terminated = true;
	}
	
	public void pause() {
		
		this.paused = true;
	}
	
	public void play() {
		
		synchronized (this) {
			
			this.paused = false;
			this.notify();
		}
	}

	public boolean isPaused() {
		return paused;
	}
}
