//Converted from the original C++ by JIST
//Use this as a basis for transcribing into Java... (good luck!)

package opensteer;

import javax.vecmath.Vector3f;

//----------------------------------------------------------------------------
//
//
//OpenSteer -- Steering Behaviors for Autonomous Characters
//
//Copyright (c) 2002-2003, Sony Computer Entertainment America
//Original author: Craig Reynolds <craig_reynolds@playstation.sony.com>
//
//Permission is hereby granted, free of charge, to any person obtaining a
//copy of this software and associated documentation files (the "Software"),
//to deal in the Software without restriction, including without limitation
//the rights to use, copy, modify, merge, publish, distribute, sublicense,
//and/or sell copies of the Software, and to permit persons to whom the
//Software is furnished to do so, subject to the following conditions:
//
//The above copyright notice and this permission notice shall be included in
//all copies or substantial portions of the Software.
//
//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
//THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
//FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
//DEALINGS IN THE SOFTWARE.
//
//
//----------------------------------------------------------------------------
//
//
//AbstractVehicle: pure virtual base class for generic steerable vehicles
//
//01-30-03 cwr: created 
//
//
//----------------------------------------------------------------------------



public interface AbstractVehicle extends AbstractLocalSpace
{
    // mass (defaults to unity so acceleration=force)
    public float mass ();

    public float setMass (float mass);


    // size of bounding sphere, for obstacle avoidance, etc.
    public float radius ();

    public float setRadius (float radius);


    // velocity of vehicle
    public Vector3f velocity ();


    // speed of vehicle  (may be faster than taking magnitude of velocity)
    public float speed ();

    public float setSpeed (float speed);
//    public Vector group;
//    public Iterator iterator;


    // predict position of this vehicle at some time in the future
    // (assumes velocity remains constant)
    public Vector3f predictFuturePosition (float predictionTime);


    // ----------------------------------------------------------------------
    // XXX this vehicle-model-specific functionality functionality seems out
    // XXX of place on the abstract base class, but for now it is expedient

    // the maximum steering force this vehicle can apply
    public float maxForce ();

    public float setMaxForce (float maxForce);


    // the maximum speed this vehicle is allowed to move
    public float maxSpeed ();

    public float setMaxSpeed (float maxSpeed);
}

