package opensteer;
import javax.vecmath.Vector3f;

import common.SimulatedObject;

// Converted from the original C++ by JIST
// Use this as a basis for transcribing into Java... (good luck!)


// ----------------------------------------------------------------------------
//
//
// OpenSteer -- Steering Behaviors for Autonomous Characters
//
// Copyright (c) 2002-2003, Sony Computer Entertainment America
// Original author: Craig Reynolds <craig_reynolds@playstation.sony.com>
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
//
//
// ----------------------------------------------------------------------------
//
//
// Obstacle and SphericalObstacle
//
// for use with obstacle avoidance
//
// 09-05-02 cwr: created
//
//
// ----------------------------------------------------------------------------
//
// XXX 4-23-03: Temporary work around.  Put steerToAvoid method here to
// XXX support generic steerToAvoidObstacle method in SteerLibraryMixin.
// XXX That in turn requires making Obstacles know about AbstractVehicle.
// XXX The final implementation will probably be significantly different.
//
// ----------------------------------------------------------------------------



public interface Obstacle extends SimulatedObject
{
// BEGIN Enumeration constants for seenFromState
    public static final int outside = 0;
    public static final int inside = 1;
    public static final int both = 2;
// END Enumeration constants for seenFromState


    public int seenFrom ();

    public void setSeenFrom (int s);


    // XXX 4-23-03: Temporary work around (see comment above)
    public Vector3f steerToAvoid (AbstractVehicle v, float minTimeToCollision);
}

