package opensteer;

import javax.vecmath.Vector3f;

// Converted from the original C++ by JIST
// Use this as a basis for transcribing into Java... (good luck!)




// ----------------------------------------------------------------------------

// ----------------------------------------------------------------------------
//
//
// OpenSteer -- Steering Behaviors for Autonomous Characters
//
// Copyright (c) 2002-2003, Sony Computer Entertainment America
// Original author: Craig Reynolds <craig_reynolds@playstation.sony.com>
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
//
//
// ----------------------------------------------------------------------------
//
//
// Pathway and PolylinePathway, for path following.
//
// 06-03-02 cwr: created
//
//
// ----------------------------------------------------------------------------

// ----------------------------------------------------------------------------
// Pathway: a pure virtual base class for an abstract pathway in space, as for
// example would be used in path following.


public interface Pathway
{
    /** Given an arbitrary point ("A"), finds the nearest point ("P") on this
     * path.  Also sets the path tangent at P and returns a flag indicating 
     *  whether or not A was already inside the Pathway "tube".
     */
    public float mapPointToPath (Vector3f point, Vector3f nearest, Vector3f tangent);


    /** given a distance along the path, convert it to a point on the path
     */
    public Vector3f mapPathDistanceToPoint (float pathDistance);


    /** Given an arbitrary point, convert it to a distance along the path.
     */
    public float mapPointToPathDistance (Vector3f point);


	public float getRadius();
}

