/*
 * Created on 18.12.2006
 *
 */
package view;

import java.awt.Graphics2D;
import java.awt.Paint;
import java.awt.TexturePaint;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.vecmath.Matrix3f;

import common.DirectDrawable;

public class GrassView implements DirectDrawable {
	
	private int width, height;
	private Paint paint;
	
	private BufferedImage image;

	/**
     * @param width
     * @param height
     */
    public GrassView(int width, int height) {
	    this.width = width;
	    this.height = height;
	    
		try {
		    image = ImageIO.read(new File("grass2.png"));
		} 
		catch (IOException e) {

		}
		paint = new TexturePaint(image, new Rectangle2D.Double(0, 0, image.getWidth(), image.getHeight()));
    }

	public void drawDirect(Graphics2D g2, Matrix3f tranform) {
	    
		Paint oldPaint = g2.getPaint();
		g2.setPaint(paint);
		
	    g2.fill(new Rectangle2D.Float(0,0, this.width, this.height));

		g2.setPaint(oldPaint);
    }

}
