package view;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.vecmath.Matrix3f;
import javax.vecmath.Vector3f;

import opensteer.SphericalObstacle;

import common.DirectDrawable;
import common.Drawable;
import core.Util;

public class SphercialObstacleView implements DirectDrawable {

	private SphericalObstacle obstacle;
	
	public SphercialObstacleView(SphericalObstacle obstacle) {
		super();
		this.obstacle = obstacle;
	}

	public void drawDirect(Graphics2D g, Matrix3f transform) {
		
		Vector3f tPosition = new Vector3f(obstacle.center.x, obstacle.center.y, 1);
		
		transform.transform(tPosition);
		
		int x = Util.round(tPosition.x);
		int y = Util.round(tPosition.y);
		int r = Util.round(obstacle.radius);
		int r2 = Util.round(obstacle.seenFrom());
		
		g.setColor(Color.WHITE);
		g.fillOval(x - r, y - r, r*2, r*2);
		
		g.setColor(Color.BLACK);
		g.drawOval(x - r, y - r, r*2, r*2);
		
		g.setColor(Color.LIGHT_GRAY);
		g.drawOval(x - r2, y - r2, r2*2, r2*2);
	}

}
