package view;
import java.awt.Color;
import java.awt.Graphics;

import javax.vecmath.Matrix3f;
import javax.vecmath.Vector3f;

import common.Drawable;
import core.Util;

public class TargetView implements Drawable {
	
	private Vector3f target;

	public TargetView(Vector3f target) {
		
		super();
		this.target = target;
	}

	public void draw(Graphics g, Matrix3f transform) {
		
		Vector3f tPosition = new Vector3f(target.x, target.y, 1);
		
		transform.transform(tPosition);
		
		int x = Util.round(tPosition.x);
		int y = Util.round(tPosition.y);
		
		g.setColor(Color.BLACK);
		
		g.drawOval(x - 15, y - 15, 30, 30);
		g.drawLine(x - 20, y, x + 20, y);
		g.drawLine(x, y - 20, x, y + 20);
	}

}
